Need help in While Condition


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting Need help in While Condition
# 1  
Old 10-30-2007
Need help in While Condition

Hi All

I am working on a script , need a help from you guys

This is below script which i have written

x=`who am i`
opt=`echo ${x} | cut -f1 -d' '`
df -d > deljil.txt
if [ "$opt" = "unix" ];then
while read line
do
sed /$line/d deljil.txt > deljil99.txt
done <unix.txt
while read cjob_name
do
opt1=`echo ${cjob_name} | cut -f1 -d' '`
echo "Success " $opt1 >> delete.ksh
done <deljil99.txt
fi

This Scripts Read the lines from a file unix.txt and then deletes those lines from deljil.txt and then add the add "Success to the Prefix "

The Problem is it reads the first line and not the second line . can any one help me on this
# 2  
Old 10-30-2007
can you paste same sample lines from unix.txt...
# 3  
Old 10-30-2007
bbb
ccc
sss
ddd

when it reads it from this file it deletes the first line bbb

but not the other lines

Thanks!!
# 4  
Old 10-30-2007
The first issue here is that sed works on the whole deljil.txt file everytime for each new value of $line. In effect each execution does works again on previously eliminated lines.
I think the behaviour would be such that the deljil99.txt would contain lines that are continuously dumped from each iteration of the while loop working on values of unix.txt.

What you need to do is a sort of grep -v operation. I'll paste the code in a little bit .......

Vj
# 5  
Old 10-30-2007
x=`who am i`
opt=`echo ${x} | cut -f1 -d' '`
df -d > deljil.txt
cp deljil.txt temp.txt
while read line
do
#sed '/'"$line"'/d' deljil.txt > deljil99.txt
egrep -v "$line" temp.txt > temp2.txt
mv temp2.txt temp.txt
done <unix.txt
mv temp.txt deljil99.txt
while read cjob_name
do
opt1=`echo ${cjob_name} | cut -f1 -d' '`
echo "Success " $opt1 >> delete.ksh
done <deljil99.txt
fi



try it and let me know if it works .....
ps .. remove deljil.txt after you are done ....

Vj
# 6  
Old 10-30-2007
Thanks a lot it worked Smilie
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Help with if condition

o/p of my command is given below My requirement is if Pnumber is 0 then stabilization.Build.2013 else stabilization.PBuild.2013.3 (11 Replies)
Discussion started by: nikhil jain
11 Replies

2. UNIX for Dummies Questions & Answers

IF [ condition ] help

Hi all Unix newbie - please be gentle Am modifying an existing script to error trap a variable with a length of 0 #!/bin/bash ipfile='/var/data/bin/ipaddress' ] && ipold="$(< "$ipfile" )" ipnew="$( wget -q -O - checkip.dyndns.org | sed -e 's/.*Current IP Address: //;s/<.*$//' )" #... (6 Replies)
Discussion started by: CRChamberlain
6 Replies

3. Shell Programming and Scripting

If condition return 0 even when it fails to satisfy te condition

HI My doubt may be basic one but I need to get it clarified.. When i use "if" condition that checks for many AND, OR logical conditions like if ]; then return 0 fi Even the if condition fails it returns as zero.. Any clue.. But if i add else condition like if ]; ... (2 Replies)
Discussion started by: Priya Amaresh
2 Replies

4. Shell Programming and Scripting

if condition

if chr1:109457160 1 109457160 99.1735537190083 + chr1:109457233 1 109457233 99.1735537190083 - chr1:109457614 1 109457614 99.1735537190083 + chr1:109457618 1 109457618 100 + chr1:109457943 1 109457943 100 - chr1:109458224 1 109458224 99.1735537190083 - file1.txt If 6th column in... (3 Replies)
Discussion started by: johnkim0806
3 Replies

5. Shell Programming and Scripting

redirect stdout echo command in condition A run in condition B

hi, I have some problems in my simple script about the redirect echo stdout command inside a condition. Why is the echo command inside the elif still execute in the else command Here are my simple script After check on the two diff output the echo stdout redirect is present in two diff... (3 Replies)
Discussion started by: jao_madn
3 Replies

6. HP-UX

Difference between [condition] and [[condition]] and ((condition)) when used with if condition

Executed the following if conditions .. and got different results . only (( )) gave correct o/p with all scenarios . Can anybody please let me know what is the difference between and ] and ((condition)) when used with if condition. And why each condition gave different result. 1.... (2 Replies)
Discussion started by: soumyabubun
2 Replies

7. Shell Programming and Scripting

If Condition

Hi, I am trying to execute this command, but is it not working, says "`;' unexpected" eval $lgrep $SAM_CMD ; if ; then ; echo "No Error" ; fi What i want is, return the command output, if it is non zero, say "No Error". Thanks, John. (21 Replies)
Discussion started by: john_prince
21 Replies

8. Shell Programming and Scripting

if..else condition

i have a paramter data_date in which i am passing a string value.i want to find out another paramter file_date from this.the logic is given below if day of data_date = sunday or monday then file_date=data_date-1 else file_date=data_date-2 i am passing data_date as 20061027. how can i... (3 Replies)
Discussion started by: dr46014
3 Replies

9. Shell Programming and Scripting

if condition

Hi friends, :) In a shell script i found the following if condition. echo -n "Which version of $1 do you want to restore ('0' to quit)? : " read desired if ${desired:=1} -ge $index ] ; then echo "$0: Restore canceled by user: index value too big." >&2 exit 1 fi Can... (1 Reply)
Discussion started by: ravi raj kumar
1 Replies

10. Shell Programming and Scripting

if condition ...

i have following if condition if above statement is case sensitive.....what is syntax if i have to make above comparision case insensetive (4 Replies)
Discussion started by: mahabunta
4 Replies
Login or Register to Ask a Question